
#include <string>
#include <cstdarg>
#include <systemc>
#include "topcell.h"

static
std::vector<std::string> stringArray(
	const char *first, ... )
{
	std::vector<std::string> ret;
	va_list arg;
	va_start(arg, first);
	const char *s = first;
	while(s) {
		ret.push_back(std::string(s));
		s = va_arg(arg, const char *);
	};
	va_end(arg);
	return ret;
}

topcell::topcell(sc_core::sc_module_name name)
    : sc_core::sc_module(name),
      fifo_gen("fifo_gen"),
      fifo_writer("fifo_writer", "soclib-pipe2fb", stringArray("soclib-pipe2fb", "320", "200", NULL)),
      fifo("fifo"),
      p_clock("p_clock"),
      p_resetn("p_resetn")
{
    fifo_gen.p_clk(p_clock);
    fifo_gen.p_fifo(fifo);
    fifo_gen.p_resetn(p_resetn);
    fifo_writer.p_clk(p_clock);
    fifo_writer.p_fifo(fifo);
    fifo_writer.p_resetn(p_resetn);
}

// For exporting to modelsim
#ifdef MTI_SYSTEMC
SC_MODULE_EXPORT(topcell);
#endif
